/* consts.h */

/* Constants */
#define HCYCLES 341 /* PPU cycles per scanline (113.6666.. CPU cycles) */
#define VLINES 262 /* Total scanlines (including vblank) */
#define VBL 27428 /* CPU cycles until VBlank interrupt */
#define CPF 29781 /* CPU cycles per frame (actually 29780.6666..) */

#define BG_TILE_SCRW 16 /* Scaled (screen) height */
#define BG_TILE_SCRH 16 

/* 113 2/3 cpu cycles per scanline */
/* = 341 ppu cycles per scanline */
/* = 81840 ppu cycles per frame (not counting vblank) */
/* = 89342 ppu cycles per frame (including vblank) */

#define PPU_CYCLES_PER_SCANLINE 341
/* FIXME Define constants for clock values. */

#define PPU_CTRL1 0x2000
#define PPU_CTRL1_NMI_ON_VBL 0x80
#define PPU_CTRL1_PPU_SEL 0x40
#define PPU_CTRL1_SPRITE_SIZE 0x20
#define PPU_CTRL1_BG_PAT_ADDR 0x10
#define PPU_CTRL1_SPRITE_PAT_ADDR 0x08
#define PPU_CTRL1_PPU_ADDR_INC 0x04
#define PPU_CTRL1_NAME_TABLE_ADDR 0x03

#define PPU_CTRL2 0x2001
#define PPU_CTRL2_BG_COLOR   0xe0
#define PPU_CTRL2_SPRITES_VISIBLE 0x10
#define PPU_CTRL2_BG_VISIBLE 0x08
#define PPU_CTRL2_SPRITE_NOCLIP 0x04
#define PPU_CTRL2_BG_NOCLIP 0x02
#define PPU_CTRL2_DISPLAY_TYPE 0x01

#define SPR_RAM_Y 0
#define SPR_RAM_TILE 1
#define SPR_RAM_ATTR 2
#define SPR_RAM_ATTR_VFLIP 0x80
#define SPR_RAM_ATTR_HFLIP 0x40
#define SPR_RAM_ATTR_PRIO  0x20
#define SPR_RAM_ATTR_COLOR 0x03
#define SPR_RAM_X 3

