/* globals.h */

#include <glide.h>

struct nes_ppu {
	unsigned int scanpage;
	unsigned int scanpage_temp;
};

/* Asm linkage */
extern int TRANS_TBL[];
extern void *INPUT;
extern void *OUTPUT;
extern void *U;
extern void *NMI;
extern int Mapper[];
extern int MAPPERNUMBER;
extern unsigned char *ROM_BASE;
extern void(*MapperInit[])();
extern void(*drawimage)();

/* Global Variables */
extern unsigned short int hscroll[],vscroll[];
extern unsigned char linereg[];
extern unsigned int controller1,controller2;
extern unsigned char spriteram[];
extern unsigned char vram[];
extern unsigned char *MAPTABLE[];
extern unsigned int hvmirror;
extern unsigned int nomirror;
extern unsigned int osmirror;
extern unsigned int CLOCK;
extern unsigned int depth;
extern unsigned int frameskip;
extern unsigned int vline;
extern unsigned int vscan;
extern unsigned int vwrap;
extern unsigned int scanpage;
extern unsigned char vscrollreg;
extern unsigned char hscrollreg;
extern unsigned int palette_24[];
extern unsigned int endframe;
extern unsigned int ttlframes;
extern struct timeval btv;
extern void *palette;
extern void *fb;
extern int updated_tiles[];
extern GrTexInfo bgtile_info;
extern FxU32 bgtile_size;
extern FxU32 bgtile_start;
extern int cached_tiles[];
extern struct nes_ppu ppu;
extern int global_display_glide_bg;
extern int global_display_glide_sprites;
extern int global_display_mini1;
extern int global_display_mini2;
extern int global_display_mini3;
extern int global_display_mini4;
extern int global_display_all_tiles;
extern int global_display_all_tiles_col;
extern int global_debug;
extern int pause_emu;
extern int sleep_emu;

/* Flags */
extern int disassemble;
extern int oldxcode;

/* Asm linkage */
extern unsigned int STACKPTR;/* Store 6502 stack pointer */
extern void *XPC;            /* Translated program counter */
extern signed int INRET;     /* Input data return value */
extern signed int CTNI;      /* Cycles to next interrupt */
extern unsigned int VRAMPTR; /* address to read/write video memory */

extern void display_palette();
extern void update_colors();
