#include <glide.h>
#include <assert.h>

/*const int ppu_cycles_per_scanline = 341; */

int global_display_glide_bg;
int global_display_glide_sprites;
int global_display_mini1;
int global_display_mini2;
int global_display_mini3;
int global_display_mini4;
int global_display_all_tiles;
int global_display_all_tiles_col;
int global_debug;

#undef CACHE_SPRITES_TEMP

#define dprintf_draw if (1 && global_debug) printf
#define dprintf_sprites if (1 && global_debug) printf
#undef DEBUG_VSCROLL

/* Skip offscreen sprites.  Undefine this to render unnecessary sprites
 * every frame, for testing sprite rendering speed. */
#define SKIP_OFFSCREEN_SPRITES

/* These are nearly obsolete, having been implemented as run-time options */
#define GLIDE_BG
#define GLIDE_SPRITES

/* These values are for and specific to the palette[] array layout. */
#define BG_PALETTE_OFFSET 0
#define SPRITE_PALETTE_OFFSET 12

#undef pixel_t

/* 
#if (DEPTH==8)
  #define pixel_t unsigned char
#endif


#if (DEPTH==32)
  #define pixel_t unsigned int
#endif 
*/

#if (DEPTH==16)
  #define pixel_t unsigned short int
#endif

#undef pixmap
#define pixmap ((pixel_t *)fb)

#undef palette
#define palette ((pixel_t *)palette)



int load_one_tile_color(int tile, int paloffset, int color);
int render_one_tile(int x, int y, int dx, int dy, int tile, int color, int z);
int render_partial_tile(int x, int y, int dx, int dy, int yskip, int tile, int color);
int display_tile_map(int x0, int y0, int dx, int dy, int scanpage);
int display_all_tiles(int x0, int y0, int dx, int dy, int color);

#define BYTES_PER_TILE_COLOR_PLANE 8
#define COLOR_TILES_PER_TILE 4
#define BGTILE_TEXTURE_AT(tile, color) (bgtile_start + bgtile_size * (tile * COLOR_TILES_PER_TILE + color))

/*#define BG_TILE_W 8   /**/  /* BG Tile true width */
/*#define BG_TILE_H 8   /**/



#if (DEPTH==8)
void drawimage8(int endclock)
#endif
#if (DEPTH==16)
void drawimage16(int endclock)
#endif
#if (DEPTH==32)
void drawimage32(int endclock)
#endif
{
  /* FIXME */
  static unsigned int lastclock=0;
  unsigned int curclock    = lastclock;
  unsigned int baseaddr    = ((RAM[0x2000]&0x10)<<8); /* 0 or 0x1000 */
  unsigned int currentline = lastclock / PPU_CYCLES_PER_SCANLINE;
  unsigned int hposition   = lastclock % PPU_CYCLES_PER_SCANLINE;
  unsigned int hpos = lastclock % PPU_CYCLES_PER_SCANLINE;
  unsigned int x;
  unsigned int scanpage;
  static pixel_t curpal[4];
  static unsigned char tilecolor;
  static int begin = 1;

if (hscrollreg) dprintf_draw("line: %d hpos: %d\n",  currentline, hposition); 

  /* FIXME If I comment out frameskip, frame counting is wrong ... */
  if(frameskip) return;



#ifdef DEBUG_VSCROLL
	if (vscrollreg) { printf("vscrollreg: %d\n", vscrollreg); }   
#endif

  if(endclock>81840) return;
  if(curclock>81840) curclock=0;
  if(endclock<=curclock) return;
/*printf("enter vline: %d\n", vline); */
  if(curclock==0)
  {
    /* Begin new frame */
#define DEBUG_VSCROLL
#ifdef DEBUG_VSCROLL
    vline=vscrollreg>>3;
    vscan=vscrollreg&7;
/*	if (vscan) printf("  vscan set\n");
	if (vline) printf("  modified vline: %d\n", vline);  */
#endif
    update_colors();
    curpal[0]=palette[24];
	begin = 1;
	ppu.scanpage = ppu.scanpage_temp;
  }

  if(hposition<85)
  {
    curpal[1]=palette[3*(tilecolor&3)];
    curpal[2]=palette[3*(tilecolor&3)+1];
    curpal[3]=palette[3*(tilecolor&3)+2];
  }

/* BG Color isn't being drawn... */
/* Orig. code draws tiles with color 0 == curpal[0] instead of "transparent",
/* which is equiv. to clearing frame to curpal[0] every frame. */
/* FIXME but is it faster to draw tiles with color 0 opaque?  Also, can we do
 * sprite-behind processing with color 0 opaque (or transparent?) */

  /* Warning: this will not only omit background, but also sprites.  Not correct.  Fixed.*/
  /* This alternates every frame, it's not working ... Fixed */
if (endframe) {

#define REDPIXEL (0x1f<<10)
#define ALPHAPIXEL 0x8000
#define GREENPIXEL ((0x1f<<5) | 0x8000)
#define BLUEPIXEL ((0x1f) | 0x8000)
#define WHITEPIXEL 0xffff
#define BLACKPIXEL 0x8000


#ifdef GLIDE_BG

if (global_display_glide_bg) {

	FxU32 xpar;
	unsigned char red, green, blue;
	red = (curpal[0] & (0x1f<<11)) >> 11 << 3;
	green = ((curpal[0] & (0x3f<<5))) >> 5 << 2;
	blue = (curpal[0] & (0x1f)) << 3;
	/* ABGR */
	xpar = (red) | (green << 8) | (blue << 16);

	/* FIXME take a look at this */
	/* This "begin" flag solution is weird; apparently curclock == 0 for multiple
		times per frame, though one would expect that to only happen once.  Doesn't
		matter for original code, b/c it never actually clears the screen, just over-
		writes it.  So we have to force only one update per frame.  I don't understand
		why curclock == 0 multiple times per frame, if that's what's actually happening. */

	/* FIXME Left 8 pixels should not be cleared to full bg color if bg clip is on.
	 * I think.  Somewhat difficult problem, b/c if clip goes from off to on, we have to
	 * clear that area. */
	if (begin) { grClipWindow(0, 0, BG_TILE_SCRW * 32, BG_TILE_SCRH * 30); grBufferClear( xpar, 0, GR_ZDEPTHVALUE_FARTHEST ); begin = 0; }

  if (RAM[PPU_CTRL2] & (PPU_CTRL2_BG_VISIBLE))
  {
  		int tile = 0;
		int k, l, lwrap;
		int cx = 0, dx = BG_TILE_SCRW;
		int cy = 0, dy = BG_TILE_SCRH;
		int lastl;
		unsigned char color;
		int my_vline;
		int vscan_skip;
		int uni_hpos, uni_scan, uni_vline, old_uni_scan; 

/* hvmirror is zero during horiz scroll, one during vert scroll */

		/* Handle the bg clipping bit in PPU Control 2.  Clip is active low.
		 * For now, we use card-level clipping. */
		if (!(RAM[PPU_CTRL2] & PPU_CTRL2_BG_NOCLIP)) {
/*			printf("BG Clip is active\n"); */
			grClipWindow(BG_TILE_SCRW, 0, BG_TILE_SCRW * 32, BG_TILE_SCRH * 30);
		} else {
/*			printf("BG Clip is disabled\n"); */
			grClipWindow(0, 0, BG_TILE_SCRW * 32, BG_TILE_SCRH * 30);
		}

		x = hscrollreg; 

my_vline = currentline / 8;

/* Some of this stuff should go *after* the rendering loop, because there may have been an
 * intervening register update since last render. */
if (hpos >= 85) {
	if ((currentline & 0x07) == 7)
		my_vline++;  /* Don't render this line again if it's completely done; start at next line.
		              * Otherwise, register updates at the very end of tiles will cause a redraw
					  * of this line, as described below.  Since end-tile updates are extremely
					  * common, we handle this case specially, or artifacts will appear.
					  * This won't be necessary when we handle partial line updates. */
	else 
		vline--; /* Last line was only partially drawn, render again in same place */
				 /* Warning: any mid-tile register updates will cause the entire row to be rendered with
				  * the new values, so e.g. mid-tile split screen is impossible--but mid-tile updates are
				  * rare.  Fixed when we handle partial line updates. */
}

/*cy = (vline / 8) * 16; */
cx = -((x&255)%8) * (BG_TILE_SCRW / 8);  /* should be / BG_TILE_W */

cy = my_vline * BG_TILE_SCRH;

/* This allows vertical scroll to occur when 2005 is set during VBL. */
vscan_skip = vscan * (BG_TILE_SCRH / 8);
cy -= vscan_skip;

/*my_vline += vline; */

/* To clip, we should clip properly at application level, not with card. */
/* This causes a black band to oscillate across the screen. */
/* printf("Clipping from %d to %d\n", currentline * 2, (endclock/PPU_CYCLES_PER_SCANLINE) * 2);
/* grClipWindow(0,currentline * 2,640,(endclock/PPU_CYCLES_PER_SCANLINE) * 2 - 1); */

/* Temporary.  Updates to registers should probably be delayed till end of scanline.  I notice that
 * sometimes 2005 is written mid-line instead of during h-blank (ex. line 63, hpos 339 is at the end
 * of a scanline but not h-blank -- new register values shouldn't be checked until end of scanline. */
/* Or, we should always render the entire scanline. */

/* 7th line is being redrawn with incorrect offset, because 2000 is being written mid-line
 * which sets the pattern table (and scanpage) and then line 7 is redrawn since this code redraws
 * the entire line.  Two solutions jump out: 1. change this code to only update partial lines (easy);
 * 2. somehow delay register sets until end of scanline (hard, since nothing gets called once per
 * scanline, I think */

/* Solution implemented: The tile row containing the last clock value to draw is completely (not
 * partially) drawn, if that clock value is somewhere mid-line (85 <= endclock's hpos < 341).
 * However, the last tile row is not drawn if the clock value is in h-blank (i.e., endclock's hpos < 85).
 * Also, the first tile row is not drawn if the clock value is mid-line (initial hpos >= 85).
 * To clarify: if we drew the last tile row last time (endclock hpos >= 85) then this time
 * we won't (initial hpos >= 85).  If we didn't draw the last tile row last time (endclock hpos < 85)
 * then we will this time (initial hpos < 85).  Since we draw a full row even if called to display
 * mid-line, and we're called just before any register change, the register changes can only affect
 * the /next/ row.  Unfortunately, they're supposed to affect the next -scanline-, but I'll
 * have to fix that later.
 * Note that even if this gets called several times during the same scanline,
 * the row will only be rendered the first time; for if the initial clock and
 * endclock are in the same line, then there's only one row, which is by
 * definition both the first and last row, and since by the above either the
 * first or last row is guaranteed not to get drawn, nothing is drawn!
 */

/* If we try to render when currentline is mid-tile, the entire line will be rerendered, since we don't
 * skip the first (rendered) lines with render_partial_tile--upper part may be incorrect (picture a 
 * screen split mid-tile), if that's even possible */

dprintf_draw("start my_vline: %d vline: %d curline/8: %d line: %d hpos: %d endclock: %d x: %d v: %d\n", my_vline, vline, currentline/8, currentline, hposition, endclock, x, vscrollreg);

lastl = endclock / PPU_CYCLES_PER_SCANLINE / 8 + vline - my_vline;
if (endclock % PPU_CYCLES_PER_SCANLINE < 85) lastl--;

dprintf_draw("rendering from line %d to %d\n", vline, lastl);

lwrap = 0;

/* Display an extra line if we're at end of screen, in case vscan != 0. */
if (endclock == 81840) lastl++;

/* Slightly redundant--if vline > 30, we'll hit the conditional below and uni_vline will
 * be reset--but it'll be useful later */
uni_scan = ppu.scanpage;
uni_vline = (vline%30);
uni_hpos = x / 8;

/* TODO !! include vscan in the offset calculation */
/*         vscan now works at beginning of frame, but not in the middle. */
/* FIXME lastl, vline, my_vline, etc. computation stuff is bogus--need to overhaul
 * io.c first, probably */
for (l = (vline); l <= lastl; l++) {

/* FIXME This conditional should be gotten rid of somehow--it needs lwrap */
	if (l >= 30 && !lwrap) {
		if(hvmirror==1)
			uni_scan ^= 1<<10;  /* h-mirror, v-layout */
		/* This could be removed if we were to skip this conditional
		 * if vline already > 30 before the for loop on l. */
		uni_vline = (vline - 30);
		lwrap++;
	}
	old_uni_scan = uni_scan;

	/* We need to show 33 tiles for partial scrolls */
	/* FIXME if x != 0, then k < 33, else k < 32 */
	for (k = 0; k < 33; k++) {

		tile=VRAM[uni_scan + (uni_vline << 5) + uni_hpos];
		color=VRAM[uni_scan + 0x3C0 + (uni_vline/4)*8 + uni_hpos/4]   /* attribute byte */
		           >> ((uni_vline&2)<<1)                              /* shr 4 if vertical tile is 2 or 3 */
		           >> (uni_hpos&2);                                   /* shr 2 if horiz. tile is 2 or 3 */
		color &= 3;

		/* FIXME baseaddr */
		render_one_tile(cx, cy, BG_TILE_SCRW, BG_TILE_SCRH,
		                tile + (baseaddr >> 4),  /* tile+0 or tile+256 */
		                color, 20);
		cx += dx;
		uni_hpos++;
		/* Eventually, we don't have to have a conditional here; we can use bit 5, convert it into
		 * a scanpage value (i.e. 0x400) and xor it with uni_scan.  I believe the special mirror
		 * cases below can be eliminated.  Have to fix emu's name table storage first, though */
		if (uni_hpos & 32) { 		/* i.e., if uni_hpos == 32, the length of every line */
			uni_hpos = 0;
			if( (!osmirror) && (nomirror || !hvmirror) ) {
				uni_scan ^= 0x400;
			}
		}
	}
	cy += dy;
	/* FIXME constants */
	cx = -((x&255)%8) * 2;
	vline++;

	uni_scan = old_uni_scan;
	uni_vline++;
	uni_hpos = x / 8;
}

/*printf("  end vline: %d\n", l); */

		/* Moving this out into UpdateDisplay results in a performance penalty, which
		 * boggles the mind, since we'd be (I think) executing it _less_ often. */
		/* Idle kills performance. */
/*		grSstIdle(); */

 	
	} else { /*	printf("endframe3\n"); */ }


}
#endif

  
  /* Sprites don't work well with strange tile scaling sizes , probably
   * because of the division performed on cx below */

/* The main problem with caching sprites is that they use a different
 * palette than ordinary tiles, but under the current scheme the same palette
 * is used for all tiles in the pattern table.  I'm not sure of an easy,
 * or possible, way to tell if a tile will be a sprite or a bg tile. */


/* Just realized that we were displaying all sprites multiple times per frame--
 * now display prevented until endclock == 81840. */
/* I don't know if or how registers updated mid-frame affect sprites.  It's illegal
 * to write to video ram so there shouldn't be any palette changes; perhaps sprite
 * data could be changed and affect sprites later on in screen; also sprite visibility
 * register might be allowed to be modified.  Can only check this by trying several
 * games. */

/* Sprite palettes aren't being set in time? */

/* Sprite data format in pattern table:
   Format is identical to bg tiles; 16 bytes comprise two color planes of one 8x8 sprite.
*/

#ifdef GLIDE_SPRITES
if (global_display_glide_sprites && endclock == 81840) {
	if (RAM[PPU_CTRL2] & PPU_CTRL2_SPRITES_VISIBLE)
	{
		int i, j, k, l;
		int cx = 0, dx = BG_TILE_SCRW;
		int cy = 0, dy = BG_TILE_SCRH;
		FxU32 sprstart;
		FxU32 sprsize;
		GrTexInfo pixmap_info;
		FxU16 pixmap_data[8*8];
		FxU16 pal_data[] = { 0, REDPIXEL|ALPHAPIXEL, GREENPIXEL|ALPHAPIXEL, BLUEPIXEL|ALPHAPIXEL };
		unsigned char _byte1, _byte2;
		unsigned char _color;
       	GrVertex vtxA, vtxB, vtxC, vtxD;
		int s, sy, stile, sattr, sx;
		/* LOOKHERE Make these shifts constants -- e.g. SPRITE_PAT_ADDR and SPRITE_PAT_ADDR_MASK */
  		int spritebase = ((RAM[PPU_CTRL1]&PPU_CTRL1_SPRITE_PAT_ADDR) >> 3) << 12; /* 0x0 or 0x1000 */
		int spritesize = 8 << ((RAM[PPU_CTRL1]&PPU_CTRL1_SPRITE_SIZE) >> 5); /* 8<<0==8, or 8<<1==16 */
		pixmap_info.smallLod = GR_LOD_8;
		pixmap_info.largeLod = GR_LOD_8;
		pixmap_info.aspectRatio = GR_ASPECT_1x1;
		pixmap_info.format	= GR_TEXFMT_ARGB_1555;
		pixmap_info.data	= pixmap_data;
		sprstart = BGTILE_TEXTURE_AT(514, 0);

		sprsize = grTexTextureMemRequired(GR_MIPMAPLEVELMASK_BOTH, &pixmap_info);
/*		printf("spritesize: %d\n", spritesize); /**/

		dprintf_sprites("! rendering all sprites 0-63 at clock %d\n", endclock); 

		/* Handle Sprite Clip bit in PPU Control 2.  Active low.  This clips sprites
		 * in the first 8 pixels.   I believe sprites with an x location of < 8 are
		 * not completely thrown away, e.g. a sprite with x==4 will still have its right
		 * half appear on-screen. */
		if (!(RAM[PPU_CTRL2] & PPU_CTRL2_SPRITE_NOCLIP)) {
			grClipWindow(BG_TILE_SCRW, 0, BG_TILE_SCRW * 32, BG_TILE_SCRH * 30);
		} else {
			grClipWindow(0, 0, BG_TILE_SCRW * 32, BG_TILE_SCRH * 30);
		}
		
		for (s = 0; s < 64; s++) {
			sy = spriteram[s*4] + 1; /* Byte contains y - 1 */
#ifdef SKIP_OFFSCREEN_SPRITES
			if (sy >= 240) continue;
#endif
			/* LOOKHERE Also skip sprites in "left 8 columns" according to Sprite Mask in PPU_CTRL2. */
			stile = spriteram[s*4+1];
			sattr = spriteram[s*4+2];
			sx = spriteram[s*4+3];

			dprintf_sprites("Sprite #%d tile %d prio %s at (%d,%d)\n", s,
			     stile, (sattr & SPR_RAM_ATTR_PRIO) ? "behind" : "front", sx, sy);

			/* LOOKHERE Use of l here is somewhat redundant. */
			if (spritesize == 16) {
				spritebase = (stile & 1) << 12; /* Odd tiles use 0x1000; even tiles use 0x0000. */
				stile &= ~1;  /* Odd tiles become "even", using alternate pattern table. */
				l = 16;
			} else {
				l = 0;
			}

			/* If VFLIP set, and sprite is 8x16, draw bottom half first. */
			if ((sattr & SPR_RAM_ATTR_VFLIP) && spritesize == 16)  { sy += 8; }


			/* Loop can execute once or twice (l can be 0 or 16) --
			 * once for 8x8 sprites, twice for 8x16. */
			for (k = 0; k <=l; k+=16) {
/* Define to check projected performance if we cache sprites. Now +~15fps. */
/* Each sprite texture is currently recomputed and uploaded every frame. */
#ifndef CACHE_SPRITES_TEMP
				for (i = 0; i < 8; i++) {
					_byte1 = VRAM[spritebase+(stile<<4)+i+k]; 
					_byte2 = VRAM[spritebase+(stile<<4)+i+8+k];
					_color=sattr & 0x03;
					/* Convert 565 RGB to 1555 ARGB. */
					pal_data[1]=(palette[SPRITE_PALETTE_OFFSET+3*(_color&3)] & 0x1f) |
					            ((palette[SPRITE_PALETTE_OFFSET+3*(_color&3)] >> 1) & 0x7fe0) | 0x8000;
					pal_data[2]=(palette[SPRITE_PALETTE_OFFSET+3*(_color&3)+1] & 0x1f) |
					            ((palette[SPRITE_PALETTE_OFFSET+3*(_color&3)+1] >> 1) & 0x7fe0) | 0x8000;
					pal_data[3]=(palette[SPRITE_PALETTE_OFFSET+3*(_color&3)+2] & 0x1f) |
					            ((palette[SPRITE_PALETTE_OFFSET+3*(_color&3)+2] >> 1) & 0x7fe0) | 0x8000;

					for (j = 0; j < 8; j++) {
							pixmap_data[i*8+j] = pal_data[ ((_byte2 & 0x80) >> 6 ) | ((_byte1 & 0x80) >> 7) ];
							_byte1<<=1; _byte2<<=1;
					}
				}


				grTexDownloadMipMap( GR_TMU0, sprstart, GR_MIPMAPLEVELMASK_BOTH, &pixmap_info );
#endif   /* #ifndef CACHE_SPRITES_TEMP */
				cx = sx * (BG_TILE_SCRW / 8);  /* Compensate for 2x scale-up. */
				cy = sy * (BG_TILE_SCRH / 8);
				grTexSource( GR_TMU0, sprstart, GR_MIPMAPLEVELMASK_BOTH, &pixmap_info );       
				vtxA.oow = 1.0f;
				vtxB = vtxC = vtxD = vtxA;
				/*ab
				  cd*/
				vtxA.x = vtxC.x =  cx ;
				vtxB.x = vtxD.x =  cx+dx ;
				vtxA.y = vtxB.y =  cy ;
				vtxC.y = vtxD.y =  cy+dy; 

				/* LOOKHERE */
				/* Logically, if we display two overlapping sprites, they'll have
				 * the same z-distance and therefore the second one will _not_
				 * overwrite the first, which is probably not what we want.  To
				 * solve, I changed the compare fxn in x11.c to GR_CMP_GEQUAL,
				 * but that displays stuff wrong!  The original GR_CMP_GREATER
				 * works better, I'm not sure why. */
				if (sattr & SPR_RAM_ATTR_PRIO) {
					vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / 30.0f;
				} else {
					vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / 10.0f;
				}
					

				/* Swap texture coordinates to effect HFLIP or VFLIP. */
				if (sattr & SPR_RAM_ATTR_HFLIP) {
					vtxA.tmuvtx[0].sow = vtxC.tmuvtx[0].sow = 255.0f;
					vtxB.tmuvtx[0].sow = vtxD.tmuvtx[0].sow = 0.0f;
				} else {
					vtxA.tmuvtx[0].sow = vtxC.tmuvtx[0].sow = 0.0f;
					vtxB.tmuvtx[0].sow = vtxD.tmuvtx[0].sow = 255.0f;
				}

				if (sattr & SPR_RAM_ATTR_VFLIP) {
					vtxA.tmuvtx[0].tow = vtxB.tmuvtx[0].tow = 255.0f;
					vtxC.tmuvtx[0].tow = vtxD.tmuvtx[0].tow = 0.0f;
				} else {
					vtxA.tmuvtx[0].tow = vtxB.tmuvtx[0].tow = 0.0f;
					vtxC.tmuvtx[0].tow = vtxD.tmuvtx[0].tow = 255.0f;
				}

				grDrawTriangle( &vtxA, &vtxD, &vtxC );
				grDrawTriangle( &vtxA, &vtxB, &vtxD );

				/* Next loop, draw bottom half of 8x16 sprite if VFLIP not set,
				 * or the top half if it is set. */
				if (spritesize == 16) {
					if (sattr & SPR_RAM_ATTR_VFLIP) { sy -= 8; }
					else { sy += 8; }
				}

			}

		}
	}
}
#endif
/*		grBufferSwap(1);    */
 
#if defined(GLIDE_BG) || defined(GLIDE_SPRITES)
	if (endclock == 81840) { 
		/* 3 4 
		   1 2 */
		/* FIXME */
		/* Actually incorrect during vertical mirroring, because data
		 * for page 0x2800 and 0x2c00 is stored at 0x2400, and data
		 * for page 0x2000 and 0x2400 is stored at 0x2000. */
		/* FIXME Constants */
		grClipWindow(0, 0, 640, 480);
		
		if (global_display_mini3) display_tile_map(0,0,8,8,0x2c00);
		if (global_display_mini4) display_tile_map(8*32,0,8,8,0x2800);
		if (global_display_mini1) display_tile_map(0,8*30,8,8,0x2000);
		if (global_display_mini2) display_tile_map(8*32,8*30,8,8,0x2400);

		/* There's no way right now to shut this off (erase it) because right part
		 * of screen is not cleared.  Could do explicit clear from x11.c. */
		grDepthMask(FXFALSE);
		if (global_display_all_tiles) display_all_tiles(512,0,8,8,global_display_all_tiles_col);
		grDepthMask(FXTRUE);
		grBufferSwap(1);
		begin = 1;
	}
#endif
}

  if((lastclock=endclock)>=81840) lastclock=0;
/*printf("exit vline: %d\n", vline); */

}

/* Loads one color variant of tile into texture memory, using the current PPU
 * palette.  The lower two color bits are taken from the pattern table now; the
 * upper two bits (the variant) are provided by parameter "color".  The variant
 * exists because the 2 attribute color bits can be different for every
 * instance of the tile on screen; we provide slots for all four variants in
 * the cache, so we don't have to reload tiles when only the attribute color
 * bits change. */

int load_one_tile_color(int tile, int paloffset, int color)
{
	FxU16 tile_data[8*8];
	FxU16 pal_data[4];
	unsigned char byte1;
	unsigned char byte2;
	unsigned int  tileaddr = tile * 16;  /* 8 bytes per color plane, 2 color planes per tile */
	int i, j;

	bgtile_info.data = tile_data;
	pal_data[0] = 0;

		/* Convert 565 RGB to 1555 ARGB. */
		/* FIXME ewwwwww */
		pal_data[1]=(palette[paloffset+3*(color&3)] & 0x1f) | ((palette[paloffset+3*(color&3)] >> 1) & 0x7fe0) | 0x8000;
		pal_data[2]=(palette[paloffset+3*(color&3)+1] & 0x1f) | ((palette[paloffset+3*(color&3)+1] >> 1) & 0x7fe0) | 0x8000;
		pal_data[3]=(palette[paloffset+3*(color&3)+2] & 0x1f) | ((palette[paloffset+3*(color&3)+2] >> 1) & 0x7fe0) | 0x8000; 
		for (i = 0; i < BYTES_PER_TILE_COLOR_PLANE; i++) {
			byte1 = VRAM[tileaddr+i]; 
			byte2 = VRAM[tileaddr+i+BYTES_PER_TILE_COLOR_PLANE];
/*			printf("load_one_tile, tile %d, val %02x/%02x\n", tile, byte1, byte2);  /**/

			for (j = 0; j < 8; j++) {
					tile_data[i*8+j] = pal_data[(int)((((byte2 & 0x80) >> 6 )) | ((byte1 & 0x80) >> 7))]; 
					byte1<<=1; byte2<<=1;
			}
		}
/*		printf("Downloading tile %d, color %d to mem %08x\n", tile, color, BGTILE_TEXTURE_AT(tile,color)); */
		grTexDownloadMipMap( GR_TMU0, BGTILE_TEXTURE_AT(tile, color), GR_MIPMAPLEVELMASK_BOTH, &bgtile_info );
	return 1;
}

/* Draws a dx by dy tile at (x,y).  color (the 2-bit value from the tile's
 * attribute byte) selects one of four variants of this tile to display.
 * If this variant isn't in the cache, or has been invalidated, it is loaded.
 * Tiles can only be invalidated by a palette update or a pattern table write.
 */

int render_one_tile(int x, int y, int dx, int dy, int tile, int color, int z)
{
   	GrVertex vtxA, vtxB, vtxC, vtxD;

	if ((! (cached_tiles[tile] & (1 << color)))) {
/*		printf("cache miss: tile %d color %d at (%d,%d)\n", tile, color, x, y); */
		load_one_tile_color(tile, BG_PALETTE_OFFSET, color);
		cached_tiles[tile] |= (1 << color);
	}

    grTexSource( GR_TMU0, BGTILE_TEXTURE_AT(tile, color), GR_MIPMAPLEVELMASK_BOTH, &bgtile_info );        
	vtxA.oow = 1.0f;
	vtxB = vtxC = vtxD = vtxA;
	vtxA.x = vtxC.x =  x ;
	vtxB.x = vtxD.x =  x+dx ;
	vtxA.y = vtxB.y =  y ;
	vtxC.y = vtxD.y =  y+dy; 
	vtxA.tmuvtx[0].sow = vtxC.tmuvtx[0].sow = 0.0f;
	vtxB.tmuvtx[0].sow = vtxD.tmuvtx[0].sow = 255.0f;
	vtxA.tmuvtx[0].tow = vtxB.tmuvtx[0].tow = 0.0f;
	vtxC.tmuvtx[0].tow = vtxD.tmuvtx[0].tow = 255.0f;
	vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / (float)z;

	/* A B
	   C D */

	grDrawTriangle( &vtxA, &vtxD, &vtxC );
	grDrawTriangle( &vtxA, &vtxB, &vtxD );
	return 1;
}

/* Render partial tile, skipping first yskip lines. Eventually, should
 * accept horiz and vert begin and end values. */
int render_partial_tile(int x, int y, int dx, int dy, int yskip, int tile, int color)
{
   	GrVertex vtxA, vtxB, vtxC, vtxD;

	assert(yskip < dy);

	if (! (cached_tiles[tile] & (1 << color))) {
		load_one_tile_color(tile, BG_PALETTE_OFFSET, color);
		cached_tiles[tile] |= (1 << color);
	}

    grTexSource( GR_TMU0, BGTILE_TEXTURE_AT(tile, color), GR_MIPMAPLEVELMASK_BOTH, &bgtile_info );        

	vtxA.oow = 1.0f;
	vtxB = vtxC = vtxD = vtxA;
	vtxA.x = vtxC.x =  x ;
	vtxB.x = vtxD.x =  x+dx ;
	vtxA.y = vtxB.y =  y + yskip;
	vtxC.y = vtxD.y =  y+dy; 
	vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / 20.0f;

	vtxA.tmuvtx[0].sow = vtxC.tmuvtx[0].sow = (float)yskip / (float)dy * 256.0f;
	vtxB.tmuvtx[0].sow = vtxD.tmuvtx[0].sow = 255.0f;
	vtxA.tmuvtx[0].tow = vtxB.tmuvtx[0].tow = (float)yskip / (float)dy * 256.0f;
	vtxC.tmuvtx[0].tow = vtxD.tmuvtx[0].tow = 255.0f;

	/* A B
	   C D */

	grDrawTriangle( &vtxA, &vtxD, &vtxC );
	grDrawTriangle( &vtxA, &vtxB, &vtxD );

	return 1;
}

#if 0
int display_tile_map(int x0, int y0, int dx, int dy, int scanpage) {
	int x, y, tile, color;
	/* Constants!! */
    unsigned int baseaddr    = ((RAM[0x2000]&0x10)<<8); /* 0 or 0x1000 */
   	GrVertex vtxA, vtxB, vtxC, vtxD;

	/* Draw background */
	vtxA.x = vtxC.x =  x0 ;
	vtxB.x = vtxD.x =  x0+dx*32 ;
	vtxA.y = vtxB.y =  y0 ;
	vtxC.y = vtxD.y =  y+dy*30; 
    /*grColorCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE );  */
	grAlphaCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);
	grAlphaBlendFunction( GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO );
    grAlphaTestFunction(GR_CMP_ALWAYS);  
	grConstantColorValue(0xc0800000);

/*	grDrawTriangle( &vtxA, &vtxD, &vtxC );
	grDrawTriangle( &vtxA, &vtxB, &vtxD ); */

	for (y = 0; y < 30; y++) {
		for (x = 0; x < 32; x++) {
			tile = VRAM[scanpage + y*32+x] + (baseaddr >> 4);
    		color=VRAM[scanpage + 0x3C0 + (x/4) + 2*(y&28)] >> ((y&2)<<1) >> (x&2); 
			color &= 3; 
			render_one_tile(x0+x*dx, y0+y*dy, dx, dy, tile,color); 
		}
	}

    grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                    GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE );
	grAlphaCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
	                GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE ); 
	grAlphaBlendFunction( GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ONE, GR_BLEND_ZERO );
    grAlphaTestFunction(GR_CMP_GREATER);  
}

#else 
int display_tile_map(int x0, int y0, int dx, int dy, int scanpage) {
	int x, y, tile, color;
	/* Constants!! */
    unsigned int baseaddr    = ((RAM[0x2000]&0x10)<<8); /* 0 or 0x1000 */
   	GrVertex vtxA, vtxB, vtxC, vtxD;

	/* Draw background */
	vtxA.x = vtxC.x =  x0 ;
	vtxB.x = vtxD.x =  x0+dx*32 ;
	vtxA.y = vtxB.y =  y0 ;
	vtxC.y = vtxD.y =  y0+dy*30; 
	/* FIXME This depth thing may cause more problems than it solves. */
	vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / 9.0f;
	grConstantColorValue(0xb0800020);
    grColorCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE ); 
	grAlphaCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);
	grAlphaBlendFunction( GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO );
    grAlphaTestFunction(GR_CMP_ALWAYS);  

	grDrawTriangle( &vtxA, &vtxD, &vtxC );
	grDrawTriangle( &vtxA, &vtxB, &vtxD ); 

/* Any way to restore previous state? */
    grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                    GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE );

	grAlphaCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
	                GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE ); 
	grAlphaBlendFunction( GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ONE, GR_BLEND_ZERO );
    grAlphaTestFunction(GR_CMP_GREATER);  

	for (y = 0; y < 30; y++) {
		for (x = 0; x < 32; x++) {
			tile = VRAM[scanpage + y*32+x] + (baseaddr >> 4);
    		color=VRAM[scanpage + 0x3C0 + (x/4) + 2*(y&28)] >> ((y&2)<<1) >> (x&2); 
			color &= 3; 
			render_one_tile(x0+x*dx, y0+y*dy, dx, dy, tile,color, 8); 
		}
	}

}
#endif

int display_all_tiles(int x0, int y0, int dx, int dy, int color) {
	int x, y, tile = 0;
   	GrVertex vtxA, vtxB, vtxC, vtxD;

	/* Draw background */
	vtxA.x = vtxC.x =  x0 ;
	vtxB.x = vtxD.x =  x0+dx*16 ;
	vtxA.y = vtxB.y =  y0 ;
	vtxC.y = vtxD.y =  y0+dy*32; 
	/* FIXME This depth thing may cause more problems than it solves. */
	vtxA.ooz = vtxB.ooz = vtxC.ooz = vtxD.ooz = 65535.0f / 9.0f;
	grConstantColorValue(0x30204000);
    grColorCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE ); 
/*	grAlphaCombine( GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,
                    GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_NONE, FXFALSE);
	grAlphaBlendFunction( GR_BLEND_SRC_ALPHA, GR_BLEND_ONE_MINUS_SRC_ALPHA,
                           GR_BLEND_ZERO, GR_BLEND_ZERO ); */
    grAlphaTestFunction(GR_CMP_ALWAYS);  
	

	grDrawTriangle( &vtxA, &vtxD, &vtxC );
	grDrawTriangle( &vtxA, &vtxB, &vtxD ); 

/* Any way to restore previous state? */
    grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
                    GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE );

	grAlphaCombine( GR_COMBINE_FUNCTION_SCALE_OTHER, GR_COMBINE_FACTOR_ONE,
	                GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE ); 
	grAlphaBlendFunction( GR_BLEND_ONE, GR_BLEND_ZERO,
                           GR_BLEND_ONE, GR_BLEND_ZERO );
    grAlphaTestFunction(GR_CMP_GREATER);  

	for (y = 0; y < 32; y++) {
		for (x = 0; x < 16; x++) {
			color &= 3;
			render_one_tile(x0+x*dx, y0+y*dy, dx, dy, tile,color, 5); 
			tile++;
		}
	}

}
