/* asm linkage for x86 */

#include "mapper.h"
#include "consts.h"

.globl START
START:
  xor %esi,%esi
  mov $VBL,%ebx
  mov %esi,CLOCK
  sub %ebx,%esi
  mov $_CODE_BASE,%ebx
  mov %esi,_CTNI
  xor %eax,%eax
  xor %ecx,%ecx
  xor %edx,%edx
  xor %ebp,%ebp
  xor %edi,%edi
  jmp *%ebx

.globl U
U:

/* This will trace all branches for debugging */
/*  mov %ebx,_PCR /* */
/*  mov -4(%esp),%ebx /* */
/*  mov %ebx,_DMOD /* */
/*  mov _PCR,%ebx /* */
/*  pusha /* */
/*  call trace /* */
/*  popa /* */
/*  mov _DMOD,%ebx /* */
/*  mov %ebx,-4(%esp) /* */
/*  mov _PCR,%ebx /* */

  test %esi,%esi
  jns NMI
  mov %ebx,_PCR
  mov -4(%esp),%ebx
  mov %ebx,_DMOD
  mov _PCR,%ebx
  cmp $0x7fff,%ebx
  jle selfmod
recompile:
  push %eax
  mov %ebx,%eax
  shr $12,%eax
  sub $_RAM,%ebx
  mov MAPTABLE(,%eax,4),%eax
  add %ebx,%eax
  mov _INT_MAP(,%eax,4),%ebx
  pop %eax
  test %ebx,%ebx
  jne 0f
recompile_always:
  pusha
  mov _PCR,%ebx
  push %ebx
  call translate
  pop %ebx
  popa
  mov _XPC,%ebx
0:
  push %ecx
  cmp $0,dolink
  jz 1f  /* to disable linking (for debugging) */
  mov _PCR,%ecx
  and $0xFFFFF000,%ecx
  cmp %ecx,_LASTBANK
  mov %ecx,_LASTBANK
  jne 1f /* don't link across memory banks - mapper might change! */
  cmp $0x7fff,%ecx
  jle 1f /* don't link to RAM code */
  mov _DMOD,%ecx
  test %ecx,%ecx
  jz 1f  /* skip null address */
  push %eax
  mov %ebx,%eax
  sub %ecx,%eax
  sub $4,%eax
  mov %eax,(%ecx)
  pop %eax
1:
  pop %ecx
  jmp *%ebx


.globl NMI
NMI:
 pusha
 mov $7,%esi
 sub _CTNI,%esi
 add CLOCK,%esi
 sub $CPF,%esi
 sbb %ecx,%ecx
 and $CPF,%ecx
 add %ecx,%esi
 mov %esi,CLOCK
 movl irqflag,%eax
 testl %eax,%eax
 jnz irq
 call donmi
 testl %eax,%eax
 jz skipint
/* do the actual NMI code */
 popa
 pusha
/* push return address */
 movl   _STACKPTR,%eax
 movb   %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
/* php */
 andl   $0x34,_FLAGS
 xorl   %ebx,%ebx
 add    $0xffffffff,%ebp
 mov    _FLAGS,%ebp
 adc    $0,%ebp
 testl  $0xff,%edi
 setz   %bl
 shll   %ebx
 orl    %ebx,%ebp
 movl   %edi,%ebx
 shrl   %ebx
 andl   $0x80,%ebx
 orl    %ebx,%ebp
 movl   _VFLAG,%ebx
 addl   $0x80,%ebx
 addl   $0xffffff00,%ebx
 sbbl   %ebx,%ebx
 andl   $0x40,%ebx
 orl    %ebp,%ebx
 movb   %bl,(%eax)
 decb   %al
 mov    %al,_STACKPTR
 popa
 movl   $0,-4(%esp)
 movl   _CTNI,%esi
 movl   MAPTABLE+60,%ebx
 andl   $0x24,_FLAGS
 orl    $0x04,_FLAGS
 movzwl 0xFFFA(%ebx),%ebx
 jmp U
2:    /* don't do NMI */
skipint:
 popa
 movl $0,-4(%esp)
 mov _CTNI,%esi
 jmp U

irq:
 movl CLOCK,%eax
 subl $VBL,%eax
 movl %eax,_CTNI
/* Check interrupt-disable flag */
 movl _FLAGS,%eax
 movl $0,irqflag
 testl $0x04,%eax
 jnz skipint
/* no interrupts while the screen is off -
/* Well, actually we should delay the countdown while scanlines aren't */
/* being drawn, instead of just dropping the interrupt as we do now. */
/* This is really only here to stop games from crashing due to unhandled */
/* interrupts. */
 movl _REG1+1,%eax
 testl $0x08,%eax
 jz skipint
/* do IRQ */
 popa
 pusha
/* push return address */
 movl   _STACKPTR,%eax
 movb   %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
/* php */
 andl   $0x34,_FLAGS
 xorl   %ebx,%ebx
 add    $0xffffffff,%ebp
 mov    _FLAGS,%ebp
 adc    $0,%ebp
 testl  $0xff,%edi
 setz   %bl
 shll   %ebx
 orl    %ebx,%ebp
 movl   %edi,%ebx
 shrl   %ebx
 andl   $0x80,%ebx
 orl    %ebx,%ebp
 movl   _VFLAG,%ebx
 addl   $0x80,%ebx
 addl   $0xffffff00,%ebx
 sbbl   %ebx,%ebx
 andl   $0x40,%ebx
 orl    %ebp,%ebx
 movb   %bl,(%eax)
 decb   %al
 mov    %al,_STACKPTR
 popa
 movl   $0,-4(%esp)
 movl   _CTNI,%esi
 movl   MAPTABLE+60,%ebx
 andl   $0x24,_FLAGS
 orl    $0x04,_FLAGS
 movzwl 0xFFFE(%ebx),%ebx
 jmp U

.globl INPUT
INPUT:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %ebx
  call input
  pop %ebx
  popa
  movl _CTNI,%esi
  movsbl _INRET,%edi
  ret

.globl OUTPUT
OUTPUT:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call output
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret


/* Mapper Linkage */

.globl MAPPER_NONE
MAPPER_NONE:
  ret

.globl MAPPER_MMC1
MAPPER_MMC1:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call mmc1
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret

.globl MAPPER_UNROM
MAPPER_UNROM:
  pusha
  push %eax
  push %ebx
  call unrom
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_CHROM
MAPPER_CHROM:
  pusha
  push %eax
  push %ebx
  call crom
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_MMC3
MAPPER_MMC3:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call mmc3
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret

.globl MAPPER_MMC2
MAPPER_MMC2:
  pusha
  push %eax
  push %ebx
  call mmc2
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_CLRDRMS
MAPPER_CLRDRMS:
  pusha
  push %eax
  push %ebx
  call clrdrms
  pop %ebx
  pop %eax
  popa
  ret

.globl MAPPER_AOROM
MAPPER_AOROM:
  pusha
  mov %esi,%ecx
  sub _CTNI,%esi
  mov %ecx,_CTNI
  add CLOCK,%esi
  sub $CPF,%esi
  sbb %ecx,%ecx
  and $CPF,%ecx
  add %ecx,%esi
  mov %esi,CLOCK
  push %eax
  push %ebx
  call aorom
  pop %ebx
  pop %eax
  popa
  movl _CTNI,%esi
  ret


/* This is an interpreter to handle self-modifying code. */
/* This is far from complete, but the most common cases are handled. */

i_next:
  test %esi,%esi
  jns NMI
  cmp $0x7fff,%ebx
  jg i_done

selfmod:
  /* This will be converted to a lookup table when it's complete */
  cmpb $0x4c,_RAM(%ebx)
  je ijmp
  cmpb $0xad,_RAM(%ebx)
  je ilda
  cmpb $0x20,_RAM(%ebx)
  je ijsr
  cmpb $0x6c,_RAM(%ebx)
  je ijmpind
  cmpb $0xb9,_RAM(%ebx)
  je ilday
  cmpb $0x8d,_RAM(%ebx)
  je ista
  cmpb $0xa9,_RAM(%ebx)
  je ildaimm
  cmpb $0xa5,_RAM(%ebx)
  je ildaz
  cmpb $0x18,_RAM(%ebx)
  je iclc
  cmpb $0xaa,_RAM(%ebx)
  je itax
  cmpb $0xbc,_RAM(%ebx)
  je ildyx
  cmpb $0x8c,_RAM(%ebx)
  je isty
  cmpb $0xa2,_RAM(%ebx)
  je ildximm
  cmpb $0xa0,_RAM(%ebx)
  je ildyimm
  cmpb $0xbd,_RAM(%ebx)
  je ildax
  cmpb $0x65,_RAM(%ebx)
  je iadcz
  cmpb $0x85,_RAM(%ebx)
  je istaz
  cmpb $0x69,_RAM(%ebx)
  je iadcimm
  cmpb $0x38,_RAM(%ebx)
  je isec
  cmpb $0xfd,_RAM(%ebx)
  je isbcx
  cmpb $0x9d,_RAM(%ebx)
  je istax
  cmpb $0x48,_RAM(%ebx)
  je ipha
  cmpb $0xe8,_RAM(%ebx)
  je iinx
  cmpb $0x4a,_RAM(%ebx)
  je ilsr
  cmpb $0x08,_RAM(%ebx)
  je iphp
  cmpb $0xea,_RAM(%ebx)
  je inop
  cmpb $0x28,_RAM(%ebx)
  je iplp
i_done:
  movl %ebx,_PCR
  movl $0,_DMOD
  jmp recompile

ijmp:
 movzwl _RAM+1(%ebx),%ebx
 add $3,%esi
 jmp i_next

ijmpind:
 movzwl _RAM+1(%ebx),%ebx
 pushl %eax
 movl  %ebx,%eax
 shrl  $0xc,%ebx
 movl  MAPTABLE(,%ebx,4),%ebx
 addl  $5,%esi
 movzwl  (%ebx,%eax,1),%ebx
 popl  %eax
 jmp i_next

ilda:
 movzwl _RAM+1(%ebx),%edi
 movl   %edi,%eax
 subl   $0x2000,%edi
 addl   $4,%esi
 addl   $3,%ebx
 cmpl   $0x3000,%edi
 jb ildainp
 movl   %eax,%edi
 shrl   $0xc,%eax
 movl   MAPTABLE(,%eax,4),%eax
 movsbl (%edi,%eax,1),%eax
 movl   %eax,%edi
 jmp i_next
ildainp:
 xchg %eax,%ebx
 call INPUT
 movl %eax,%ebx
 movl %edi,%eax
 jmp i_next

ijsr:
 pushl  %eax
 mov    _STACKPTR,%eax
 add    $2,%ebx
 mov    %bh,(%eax)
 decl   %eax
 orl    $0x100,%eax
 movb   %bl,(%eax)
 decb   %al
 addl   $6,%esi
 movb   %al,_STACKPTR
 popl   %eax
 movzwl _RAM-1(%ebx),%ebx
 jmp i_next

ilday: /* FIXME: doesn't check for I/O operation */
 movzwl _RAM+1(%ebx),%eax
 andl  $0xff,%edx
 addl  %edx,%eax
 movl  %eax,%edi
 cmpb  %dl,%al
 adcl  $4,%esi  /* 1 extra cycle if page boundary is crossed (dl>al) */
 shrl   $0xc,%eax
 movl   MAPTABLE(,%eax,4),%eax
 movsbl (%edi,%eax,1),%eax
 movl   %eax,%edi
 add $3,%ebx
 jmp i_next

ista:
 addl  $3,%ebx
 pushl %ebx
 movzwl _RAM-2(%ebx),%ebx
 addl  $4,%esi
 subl  $0x2000,%ebx
 cmpl  $0x3000,%ebx
 jb    istaout
 addl  $0x2000,%ebx
 testl $0x8000,%ebx
 jnz   istamapper
 movb  %al,_RAM(%ebx)
 popl %ebx
 jmp i_next
istaout:
 addl $0x2000,%ebx
 call OUTPUT
 popl %ebx
 jmp i_next
istamapper:
 pushl %ecx
 movl MAPPERNUMBER,%ecx
 movl Mapper(,%ecx,4),%ecx
 call *%ecx
 popl %ecx
 popl %ebx
 jmp i_next

ildaimm:
 movsbl _RAM+1(%ebx),%eax
 movl %eax,%edi
 addl $2,%ebx
 addl $2,%esi
 jmp i_next

ildaz:
 movzbl _RAM+1(%ebx),%eax
 movsbl _RAM(%eax),%eax
 movl %eax,%edi
 addl $2,%ebx
 addl $3,%esi
 jmp i_next

iclc:
 xorl   %ebp,%ebp
 addl   $2,%esi
 addl   $1,%ebx
 jmp i_next

itax:
 movl   %eax,%ecx
 addl   $2,%esi
 movsbl %cl,%edi
 addl   $1,%ebx
 jmp i_next

ildyx: /* FIXME: Does not check for I/O operations */
 movzwl _RAM+1(%ebx),%edx
 andl  $0xff,%ecx
 addl  %ecx,%edx
 movl  %edx,%edi
 cmpb  %cl,%dl
 adcl  $4,%esi  /* 1 extra cycle if page boundary is crossed (cl>dl) */
 shrl   $0xc,%edx
 movl   MAPTABLE(,%edx,4),%edx
 movsbl (%edi,%edx,1),%edx
 movl   %edx,%edi
 add $3,%ebx
 jmp i_next

isty:
 addl  $3,%ebx
 pushl %ebx
 movzwl _RAM-2(%ebx),%ebx
 addl  $4,%esi
 subl  $0x2000,%ebx
 cmpl  $0x4000,%ebx
 jb    istyout
 addl  $0x2000,%ebx
 testl $0x8000,%ebx
 jnz   istymapper
 movb  %dl,_RAM(%ebx)
 popl %ebx
 jmp i_next
istyout:
 addl $0x2000,%ebx
 xchg %edx,%eax
 call OUTPUT
 xchg %edx,%eax
 popl %ebx
 jmp i_next
istymapper:
 pushl %ecx
 movl MAPPERNUMBER,%ecx
 movl Mapper(,%ecx,4),%ecx
 xchg %edx,%eax
 call *%ecx
 xchg %edx,%eax
 popl %ecx
 popl %ebx
 jmp i_next

ildximm:
 movsbl _RAM+1(%ebx),%ecx
 movl %ecx,%edi
 addl $2,%ebx
 addl $2,%esi
 jmp i_next

ildyimm:
 movsbl _RAM+1(%ebx),%edx
 movl %edx,%edi
 addl $2,%ebx
 addl $2,%esi
 jmp i_next

ildax: /* FIXME: Does not check for I/O */
 movzwl _RAM+1(%ebx),%eax
 andl  $0xff,%ecx
 addl  %ecx,%eax
 movl  %eax,%edi
 cmpb  %cl,%al
 adcl  $4,%esi  /* 1 extra cycle if page boundary is crossed (cl>al) */
 shrl   $0xc,%eax
 movl   MAPTABLE(,%eax,4),%eax
 movsbl (%edi,%eax,1),%eax
 movl   %eax,%edi
 add $3,%ebx
 jmp i_next

iadcz:
 movsbl %al,%eax
 pushl  %ebx
 movzbl _RAM+1(%ebx),%ebx
 movsbl _RAM(%ebx),%ebx
 addl   $0xffffffff,%ebp
 adcl   %ebx,%eax
 leal   3(%esi),%esi
 sbbl   %ebp,%ebp
 popl   %ebx
 movl   %eax,_VFLAG
 addl   $2,%ebx
 movsbl %al,%edi
 jmp i_next

istaz:
 addl  $2,%ebx
 pushl %ebx
 movzbl _RAM-1(%ebx),%ebx
 addl  $3,%esi
 movb  %al,_RAM(%ebx)
 popl %ebx
 jmp i_next

iadcimm:
 movsbl %al,%eax
 pushl  %ebx
 movsbl _RAM+1(%ebx),%ebx
 addl   $0xffffffff,%ebp
 adcl   %ebx,%eax
 leal   2(%esi),%esi
 sbbl   %ebp,%ebp
 popl   %ebx
 movl   %eax,_VFLAG
 addl   $2,%ebx
 movsbl %al,%edi
 jmp i_next

isec:
 orl    $0xFFFFFFFF,%ebp
 addl   $2,%esi
 addl   $1,%ebx
 jmp i_next

isbcx: /* No I/O */
 pushl  %ebx
 movzwl _RAM+1(%ebx),%ebx
 andl   $0xff,%ecx
 addl   %ecx,%ebx
 movl   %ebx,%edi
 cmpb   %cl,%bl
 adcl   $4,%esi  /* 1 extra cycle if page boundary is crossed (cl>bl) */
 shrl   $0xc,%ebx
 movl   MAPTABLE(,%ebx,4),%ebx
 movsbl %al,%eax
 movsbl (%edi,%ebx,1),%ebx
 xorl   $0xffffffff,%ebx
 addl   $0xffffffff,%ebp
 adcl   %ebx,%eax
 sbbl   %ebp,%ebp
 movl   %eax,_VFLAG
 movsbl %al,%edi
 popl   %ebx
 addl   $3,%ebx
 jmp i_next

istax:
 addl  $3,%ebx
 andl  $0xFF,%ecx
 pushl %ebx
 movzwl _RAM-2(%ebx),%ebx
 addl  %ecx,%ebx
 addl  $5,%esi
 subl  $0x2000,%ebx
 cmpl  $0x4000,%ebx
 jb    istaout
 addl  $0x2000,%ebx
 testl $0x8000,%ebx
 jnz   istamapper
 movb  %al,_RAM(%ebx)
 popl %ebx
 jmp i_next

ipha:
 push   %ebx
 movl   STACKPTR,%ebx
 addl   $0x3,%esi
 movb   %al,(%ebx)
 decb   %bl
 movb   %bl,STACKPTR
 popl   %ebx
 incl   %ebx
 jmp i_next

iinx:
 inc %ecx
 inc %ebx
 add $2,%esi
 movsbl %cl,%edi
 jmp i_next

ilsr:
 shrl %eax
 incl %ebx
 sbbl %ebp,%ebp
 andl $0x7f,%eax
 addl $2,%esi
 movl %eax,%edi
 jmp i_next

iphp:
 pushl  %ebx
 andl   $0x34,FLAGS
 xorl   %ebx,%ebx
 add    $0xffffffff,%ebp
 mov    FLAGS,%ebp
 adc    $0,%ebp
 testl  $0xff,%edi
 setz   %bl
 shll   %ebx
 orl    %ebx,%ebp
 movl   %edi,%ebx
 orl    $0x20,%ebp
 shrl   %ebx
 andl   $0x80,%ebx
 orl    %ebx,%ebp
 movl   VFLAG,%ebx
 addl   $0x80,%ebx
 addl   $0xffffff00,%ebx
 sbbl   %ebx,%ebx
 andl   $0x40,%ebx
 orl    %ebp,%ebx
 movl   STACKPTR,%ebp
 movb   %bl,(%ebp)
 andl   $0x1,%ebx
 decb   STACKPTR
 movl   %ebx,%ebp
 popl   %ebx
 addl   $3,%esi
 incl   %ebx
 jmp i_next

inop:
 inc %ebx
 add $2,%esi
 jmp i_next

iplp:
 movl   STACKPTR,%edi
 subl   $0xff,%edi
 orl    $0x100,%edi
 movl   %edi,STACKPTR
 movl   (%edi),%ebp
 addl   $4,%esi
 movl   %ebp,FLAGS
 leal   0x0(,%ebp,8),%edi
 xorl   $0x2,%ebp
 andl   $0x200,%edi
 andl   $0x1,%ebp
 andl   $0x34,FLAGS
 movl   %edi,VFLAG
 leal   (%ebp,%ebp,1),%edi
 andl   $0x104,%edi
 incl   %ebx
 jmp i_next
